#pragma inline

#include <dos.h>
#include <conio.h>
#include <stdio.h>

typedef unsigned short U8;
typedef unsigned short U16;
typedef unsigned long  U32;

#define InPort inport
U32 InPortDW(U16 Port);
void OutPortDW(U16 Port, U32 Value);
U16 PCIDetect(U16 TargetVID, U16 TargetDID);
void BlockDWord(U32 D);

void main(void)
{
    U16 Base = PCIDetect(0x494F, 0x0C69);
    if ( Base < 0x1000 )
    {
        cputs("card not found!\r\n");
        return;
    }

    directvideo = 1;
    textmode(C4350);
    clrscr();

    OutPortDW(Base + 0x10, 0);
    OutPortDW(Base + 0x14, 0);
    OutPortDW(Base + 0x18, 0);
    while ( ! kbhit() )
    {
        U32 A = ~InPortDW(Base + 0);
        U32 B = ~InPortDW(Base + 0);
        U32 C = ~InPortDW(Base + 0);

        OutPortDW(Base + 0x10, A);
        OutPortDW(Base + 0x14, B);
        OutPortDW(Base + 0x18, C);

        gotoxy(1, 1);
        BlockDWord(A);
        gotoxy(1, 2);
        BlockDWord(B);
        gotoxy(1, 3);
        BlockDWord(C);
    }
}

U32 InPortDW(U16 Port)
{
    asm {
        mov     dx,[Port]
        in      eax,dx
    }

    return _EAX;
}

void OutPortDW(U16 Port, U32 Value)
{
    asm {
        mov     dx,[Port]
        mov     eax,[Value]
        out     dx,eax
    }
}

U16 PCIDetect(U16 TargetVID, U16 TargetDID)
{
    U16 Bus, Device;
    union
    {
        struct
        {
            unsigned char Addr;
            unsigned char Function: 3;
            unsigned char Device: 5;
            unsigned char Bus;
            unsigned char Header;
        } P;
        unsigned long Trans;
    } Trans;

    Trans.P.Header = 0x80;
    Trans.P.Addr = 0;
    Trans.P.Function = 0;
    for ( Bus = 0; Bus < 256; ++Bus )
    {
        Trans.P.Bus = Bus;
        U16 DevicesOnBus = 0;
        for ( Device = 0; Device < 32; ++Device )
        {
            Trans.P.Device = Device;
            U16 ID;
            OutPortDW(0xCF8, Trans.Trans);
            ID = InPort(0xCFC);
            if ( ID == 0xFFFF ) continue;
            ++DevicesOnBus;
            if ( ID != TargetVID ) continue;
            ID = InPort(0xCFE);
            if ( ID != TargetDID ) continue;

            OutPortDW(0xCF8, Trans.Trans | 0x18);
            return InPortDW(0xCFC) & 0xFFF8;
        }
        if ( DevicesOnBus == 0 ) break;
    }
    return 0x300;
}

void BlockByte(U8 B)
{
    for ( int I = 0; I <= 7; ++I )
    {
        putch( B&1 ? '' : '' );
        B >>= 1;
    }
}

void BlockDWord(U32 D)
{
    BlockByte(D);
    putch(' ');
    D >>= 8;
    BlockByte(D);
    putch(' ');
    D >>= 8;
    BlockByte(D);
    putch(' ');
    D >>= 8;
    BlockByte(D);
}